{
Klientsk st je v principu velice jednoduch, algoritmicky nezajmav.
Co bylo nutn udlat
- zskat ze serveru a zobrazit seznam stanic
- od uivatele zskat sprvn data
- zaslat poadavek
- zobrazit odpov

Komunikaci pes http jsem provedl jednodue pomoc komponenty ze skupiny indy,
indy http client. Tm odpadla veker starost s protokolem.

Na parsing xml jsem pouil xml parser pmo od microsoftu, ten prci s daty
vrazn zjednoduil.

Snail jsem se oetit vjimky na vstupech  od uivatele.

Sestaven a zasln poadavku bylo s indy http snadn, abych mohl pout xml
parser, uloil jsem vdy data na disk do souboru.

Samotn zobrazen dat ve stromov struktue pak pmo kopruje strukturu xml,
take nevznikaly dn komplikace.

Pro bli informace viz komente pmo v kdu.
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MSXML_TLB, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdHTTP, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    IdHTTP1: TIdHTTP;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    vyber_z: TComboBox;
    vyber_do: TComboBox;
    vyber_pres: TComboBox;
    odjezd: TEdit;
    Button2: TButton;
    Label4: TLabel;
    prestupu: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    vysledku: TEdit;
    Label7: TLabel;
    server: TEdit;
    port: TEdit;
    Label8: TLabel;
    Label9: TLabel;
    GroupBox1: TGroupBox;
    vysledek: TTreeView;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

var koren: ttreenode;

implementation

{$R *.dfm}



//stisk tlatka pipojit
procedure TForm1.Button1Click(Sender: TObject);
var soub: textfile;     // pomocn textov soubor
var seznam: string;     //sem se ulo odpov serveru

var xmlsoubor: msxml_tlb.IXMLDOMDocument; //prce se souborem
var stanice: ixmldomnodelist;             //a s uzlem (v seznamu stanic je jen jedna rove vnoen

var i: integer;  //pomocn


begin
        try
                i :=  strtoint(port.text);    //naten sla portu, oeten chyb
        except on E: EConvertError do
                begin
                i := 80;
                showmessage('Neplatn port - nastaveno 80');
                port.text := '80';
                end;
        end;


        idhttp1.Port := i;
        seznam := idhttp1.Get('http://' + server.text+ '/SeznamStanic');   //dotaz na seznam stanic


        assignfile(soub, 'data.xml');
        rewrite(soub);

        write(soub, seznam);

        closefile(soub);


        xmlsoubor:=msxml_tlb.CoDOMDocument.Create;
        xmlsoubor.load('data.xml');
        stanice:=xmlsoubor.selectNodes('//Stanice');     //naten xml





        vyber_z.Items.Clear;
        vyber_do.Items.Clear;
        vyber_pres.Items.Clear;

        
        vyber_pres.Items.add('-- nerozhoduje --');
        for i:=0 to stanice.length-1 do                   //pepis do combobox
        begin
                vyber_z.Items.Add(stanice.item[i].text);
                vyber_do.Items.Add(stanice.item[i].text);
                vyber_pres.Items.Add(stanice.item[i].text);
        end;


        vyber_z.ItemIndex := 0;      //vybrn prvnch poloek
        vyber_do.ItemIndex := 0;
        vyber_pres.ItemIndex := 0;

        button2.Enabled := true;



end;








//stisk tlatka vyhledat
procedure TForm1.Button2Click(Sender: TObject);
var i, j, k, cas_odjezdu, pocet_prestupu, pocet_vysledku: integer;
var pomoc: integer;
var pokracovat: boolean;

var dotaz: string;




var soub: textfile;
var odpoved: string;

var xmlsoubor: msxml_tlb.IXMLDOMDocument;
var spoje, linky, stanice: ixmldomnodelist;



var spoj, linka: ttreenode;
begin
         //oeten nestandardnch vstup od uivatele
        pokracovat := true;

        if length(odjezd.Text) < 3 then
                pokracovat := false;

        for i := 0 to length(odjezd.text) - 1 do
                if (odjezd.text[i] >= 'A') then
                        pokracovat := false;


       if length(prestupu.Text) < 1 then
                pokracovat := false;


       if length(vysledku.Text) < 1 then
                pokracovat := false;




       try
           cas_odjezdu := strtoint(odjezd.text);
       except on E: EConvertError do
                begin
                showmessage('Chybn zadan as!');
                pokracovat := false;
                cas_odjezdu := 0;
                end;
        end;


       pomoc := cas_odjezdu MOD 1000;   //zjitn hodin a minut
       pomoc := cas_odjezdu MOD 100;
       if pomoc > 59 then
       begin
                pokracovat := false;
                showmessage('Minuty nejsou z intervalu <00; 59>!');
       end;

       pomoc := cas_odjezdu - pomoc;

       if pomoc > 2300 then
       begin
                pokracovat := false;
                showmessage('Hodiny nejsou z intervalu <00; 23>!');
       end;


        try
                pocet_prestupu :=  strtoint(prestupu.text);
        except on E: EConvertError do
                begin
                showmessage('Chybn zadan poet pestup!');
                pokracovat := false;
                end;
        end;


        try
                pocet_vysledku :=  strtoint(vysledku.text);
        except on E: EConvertError do
                begin
                showmessage('Chybn zadan poet vsledk!');
                pokracovat := false;
                end;
        end;


       if pokracovat then //pokud je po vech testech stle ve v podku...
       begin
            dotaz := '/NajdiSpojeni?odkud=' + vyber_z.Items[vyber_z.itemindex] + '&kam=' + vyber_do.Items[vyber_do.itemindex];
              //sestavme dotaz

            dotaz := dotaz +  '&odjezd=';
            if cas_odjezdu < 1000 then
                dotaz := dotaz + '0';

            dotaz := dotaz + inttostr(cas_odjezdu);


            if pocet_prestupu > 0 then
                dotaz := dotaz + '&prestupy=' + inttostr(pocet_prestupu);

            if pocet_vysledku > 0 then
                dotaz := dotaz + '&spojeni=' + inttostr(pocet_vysledku);



            if(vyber_pres.ItemIndex > 0)  then
                dotaz := dotaz + '&pres=' + vyber_pres.Items[vyber_pres.itemindex] ;


        //nahrazen mezer znaky '+'
       for i := 0 to length(dotaz) do
                if dotaz[i] = ' ' then dotaz[i] := '+';

       odpoved := idhttp1.Get('http://' + server.text + dotaz);
      //dotaz

        assignfile(soub, 'data.xml');
        rewrite(soub);

        write(soub, odpoved);

        closefile(soub);

                //a parsing...
        xmlsoubor:=msxml_tlb.CoDOMDocument.Create;
        xmlsoubor.load('data.xml');
        spoje := xmlsoubor.selectNodes('//Spoj');


        vysledek.Items.Clear;

        //vytvoen koenu stromu s vsledky
        koren := vysledek.Items.Addfirst(nil, vyber_z.Items[vyber_z.itemindex] + ' -> ' + vyber_do.items[vyber_do.itemindex]);

        if spoje.length = 0 then
                vysledek.items.addchild(koren, 'Nic nebylo nalezeno.');

         //pro kad nalezen spoj provedeme toto:
         //pro kadou linku z danho spoje vypeme vechny zastvky
         //zptn dopisujeme asy odjezd a pjezd - v dob vytvoen danho uzlu jet nejsou
         //znmy
        for i := 0 to spoje.length - 1 do
        begin
                spoj := vysledek.items.addchild(koren, 'spoj ' + inttostr(i + 1));
                linky := spoje.item[i].selectNodes('Linka');



                for j := 0 to linky.length - 1 do
                begin
                        linka := vysledek.items.addchild(spoj, 'Linka ' + linky.item[j].attributes.item[0].text);
                        stanice := linky.Item[j].selectnodes('Stanice');

                        for k := 0 to stanice.length - 1 do
                        begin
                                if k = 0 then
                                begin
                                        vysledek.items.addchild(linka, stanice.item[k].text + ' - odj. ' + stanice.item[k].attributes.item[0].text);
                                        linka.Text := linka.text + ' (' + stanice.item[k].attributes.item[0].text;
                                        if j = 0 then
                                                spoj.Text := spoj.text + ' ('+ stanice.item[k].attributes.item[0].text;
                                end
                                else if k = stanice.length - 1 then
                                begin
                                        vysledek.items.addchild(linka, stanice.item[k].text + ' - pj. ' + stanice.item[k].attributes.item[0].text) ;
                                        linka.Text := linka.text + ' - ' + stanice.item[k].attributes.item[0].text+')';
                                        if j = linky.length - 1 then
                                                spoj.Text := spoj.text + ' - '+ stanice.item[k].attributes.item[0].text + ')';
                                end
                                else
                                begin
                                        if stanice.item[k].attributes.length = 2 then
                                                vysledek.items.addchild(linka, stanice.item[k].text + ' - pj. ' + stanice.item[k].attributes.item[0].text + ', odj. ' + stanice.item[k].attributes.item[1].text)
                                        else
                                                 vysledek.items.addchild(linka, stanice.item[k].text + ' - odj. ' + stanice.item[k].attributes.item[0].text);
                                end;
                        end;
                end;

        end;
        koren.Expand(false); //rozbalme pouze koen
        button3.Enabled := true;  //a zapneme tlatka pro sbalen/rozbalen
        button4.Enabled := true;



       end;



end;
  //procedury pro sbalen a rozbalen celho stromu s vsledky
procedure TForm1.Button3Click(Sender: TObject);
begin
        koren.Collapse(true);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
        koren.Expand(true);
end;

end.
